def K8S_TEMPLATE = """
apiVersion: v1
kind: Pod
spec:
  containers:
  - name: docker
    image: docker:latest
    command:
    - sh
    env:
    - name: DOCKER_HOST
      value: "tcp://ws-dev-0.fwc.dc.dev.apps.vm:2375"
    tty: true
"""

pipeline {
    agent any
    environment {
        PLACEHOLDER = "changeme"
    }
    stages {
        stage('Initialise Agent') {
            agent { kubernetes yaml: "${K8S_TEMPLATE}" }
            stages {
                stage('OCI: Status') {
                    steps {
                        container('docker') {
                            sh 'docker ps -a'
                        }
                    }
                }
                stage('OCI: pull') {
                    steps {
                        container('docker') {
                            sh 'docker pull hello-world'
                        }
                    }
                }
                stage('OCI: run') {
                    steps {
                        container('docker') {
                            sh 'docker run --name hello-world hello-world'
                        }
                    }
                }
                stage('OCI: stop') {
                    steps {
                        container('docker') {
                            sh 'docker stop hello-world'
                        }
                    }
                }
                stage('OCI: delete container') {
                    steps {
                        container('docker') {
                            sh 'docker rm hello-world'
                        }
                    }
                }
                stage('OCI: delete oci image') {
                    steps {
                        container('docker') {
                            sh 'docker rmi hello-world'
                        }
                    }
                }
            }
        }
    }
}